#ifndef MAIN_H
#define MAIN_H

#include <climits>

#define gmexport extern "C" __declspec (dllexport)

template<typename A> A gm_cast(double);
template<> inline unsigned long gm_cast<unsigned long>(double d) {
	if((double)(unsigned long)(0)<=d && d<=(double)(unsigned long)(ULONG_MAX)) return (unsigned long)(d);
	else return 0;
}
template<> inline long gm_cast<long>(double d) {
	if((double)(long)(LONG_MIN)<=d && d<=(double)(long)(LONG_MAX)) return (long)(d);
	else return 0;
}
template<> inline unsigned int gm_cast<unsigned int>(double d) {
	if((double)(unsigned int)(0)<=d && d<=(double)(unsigned int)(UINT_MAX)) return (unsigned int)(d);
	else return 0;
}
template<> inline int gm_cast<int>(double d) {
	if((double)(int)(INT_MIN)<=d && d<=(double)(int)(INT_MAX)) return (int)(d);
	else return 0;
}
/*template<> inline bool gm_cast<bool>(double d) {
	return (d>=0.5);
}*/

#endif // MAIN_H

